# -*- coding: utf-8 -*-
from tokenizer import *
from converter import * 
import types
# Build the lexer
import lex
# lex.lex(optimize=1)
lex.lex()

#try:
#	s = u"<Literal, 44>word(#'name')"
#	lex.input(s)
#	
#	tok=lex.token()
#	while tok:
#		print tok
#		tok = lex.token()
#except EOFError:
#	print 'ex'

# Parsing rules

precedence = (
	('right', 'EQU'),
	('right', 'IMPL'),
	('left', 'OR'),
	('left', 'AND'),
	('left', 'NOT'),
	('right', 'ROMB', 'SQU'),
	)

# dictionary of names
# names = { }
conv = SQLConverter();
# def p_statement_assign(t):
#     'statement : NAME EQUALS expression'
#     names[t[1]] = t[3]
# 
def p_statement_expr(t):
	'statement : expression'
	t[0] = t[1]
def p_expression_id(t):
	'expression : NUMBER'
	t[0] = conv.const(t[1])
def p_value_qname(t):
	"""value : NUMBER 
	| QNAME
	"""
	t[0] = t[1]
def p_value_rel(t):
	'rel : NAME'
	t[0] = conv.rel(t[1])
def p_value_rev(t):
	'rel : REV NAME'
	t[0] = conv.revrel(t[2])
def p_expression_func(t):
	'expression : NAME LP value RP'
	t[0] = conv.func(t[1], t[3])
def p_expression_major_romb_exact(t):
	'expression : LT rel COMA NOT NUMBER GT expression %prec ROMB'
	t[0] = conv.major_romb_exact(t[2], t[5], t[7])
def p_expression_major_romb_fraction(t):
	'expression : LT rel COMA NUMBER COLON NUMBER GT expression %prec ROMB'
	t[0] = conv.major_romb_fraction(t[2], t[4],  t[6],  t[8])
def p_expression_major_romb(t):
	'expression : LT rel COMA NUMBER GT expression %prec ROMB'
	t[0] = conv.major_romb(t[2], t[4],  t[6])
def p_expression_major_squ_fraction(t):
	'expression : LB rel COMA NUMBER COLON NUMBER RB expression %prec SQU'
	t[0] = conv.major_romb_fraction(t[2], t[4],  t[6],  t[8])
def p_expression_major_squ(t):
	'expression : LB rel COMA NUMBER RB expression %prec SQU'
	t[0] = conv.major_squ(t[2], t[4],  t[6])
def p_expression_romb(t):
	'expression :  LT rel GT expression %prec ROMB'
	t[0] = conv.romb(t[2], t[4])
#     t[0] = 'romb(rel(' + t[2] + '),' + t[4] + ')'
def p_expression_squ(t):
	'expression :  LB rel RB expression %prec SQU'
	t[0] = conv.squ(t[2], t[4])
def p_expression_squ(t):
	'expression :  LB rel RB expression %prec SQU'
	t[0] = conv.squ(t[2], t[4])

def p_expression_not(t):
	'expression : NOT expression'
	#print "not found"
	t[0] = conv.neg(t[2])

def p_expression_and(t):
	'expression : expression AND expression'
	t[0] = conv.conj(t[1], t[3])

def p_expression_or(t):
	'expression : expression OR expression'
	t[0] = conv.disj(t[1], t[3])

def p_expression_impl(t):
	'expression : expression IMPL expression'
	t[0] = conv.impl(t[1], t[3])

def p_expression_equ(t):
	'expression : expression EQU expression'
	t[0] = conv.equ(t[1], t[3])

def p_expression_group(t):
	'expression : LP expression RP'
	t[0] = t[2]

def p_expression_var(t):
	'expression : VAR NAME'
	t[0] = conv.var(t[1]+t[2])

def p_error(t):
	if(t):
		print "Syntax error at '%s'" % t.value
	else :
		print "Syntax error at end of input"

import yacc

class Processor:
	def __init__(self):
		yacc.yacc()
	def process(self, s):
		if( type(s) is types.StringType):
			s = s.decode("utf8")
		
		#x = s.decode('utf-8')
		query = yacc.parse(s)
		return query #NB
		#return query.encode('utf-8') #NB

