# -*- coding: utf-8 -*-

# Copyright 2006-2012 Borislav Rizov <bobyATdclDOTbasDOTbg>, Department of Computational Linguistic, Institute for Bulgarian Language – Bulgarian Academy of Sciences
# 
# This file is part of Hydra.
# 
# Hydra is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Hydra is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Hydra.  If not, see <http://www.gnu.org/licenses/>.

from Tix import *
from wordnet import wn
from observer_context import VMessage, VM
class SynsetView(Frame):
    def create_widgets(self):
        
        self.text_box = Text(self, state = 'disabled', bg = 'ivory')
        self.text_box.pack(fill = BOTH, expand = 1)
        self.text_box.tag_config('redtag', foreground = 'red')
        self.text_box.tag_config('bluetag', foreground = 'blue')
        self.text_box.tag_config('greentag', foreground = 'green')
        self.text_box.tag_config('blacktag', foreground = 'black')
    def __init__(self, dict, parent = None):
        Frame.__init__(self, parent)
        self.synset = None
        self.dict = dict
        self.create_widgets()
        self.ling = None
    def set_synset(self, synset):
        self.synset = synset
    def refresh(self, message):
        self.ling = ling = message.data
        if ling:
            self.synset = ling.synset()
            self.draw()
        else:
            self.clear()
    def clear(self):
        tb = self.text_box
        tb.configure(state = 'normal') # Enable
        tb.delete('1.0', 'end')
        tb.configure(state = 'disabled') # Disable
    def draw(self):
        tb = self.text_box
        tb.configure(state = 'normal') # Enable
        
        tb.delete('1.0', 'end')
        tb.insert('end',"id: ", 'bluetag');
        tb.insert('end',self.synset.ID(), 'bluetag');
        tb.insert('end',"\n\n")
        
        tb.insert('end',"Pos: ", 'bluetag');
        tb.insert('end', self.synset.to_string("pos"), 'redtag');
        tb.insert('end',"\t")
        
        tb.insert('end',"ID: ", 'bluetag');
        tb.insert('end', self.synset.to_string("ili"), 'redtag');
        tb.insert('end',"\t")
        
        tb.insert('end',"BCS: ", 'bluetag');
        tb.insert('end', self.synset.to_string("bcs"), 'redtag');
        tb.insert('end',"\n\n")
        
        for rn, rel in wn.relations.iteritems():
            ilrs = rel.neighbours(self.synset)
            x = False
            for ilr in ilrs:
                tb.insert('end', rn, 'bluetag')
                tb.insert('end', " " + ilr.to_string())
                tb.insert('end',"\n");
                x = True
            if x:
                tb.insert('end', '\n')
            
        tb.insert('end',"Definition: ", 'bluetag');
        tb.insert('end', self.synset.to_string("definition"), 'redtag');
        tb.insert('end',"\n");
        tb.insert('end',"\n");

        tb.insert('end',"Domain: ", 'bluetag');
        tb.insert('end', self.synset.to_string("domain"), 'greenetag');
        tb.insert('end',"\n");
        tb.insert('end',"\n");
        
        tb.insert('end',"stamp: ", 'bluetag');
        tb.insert('end', self.synset.to_string("stamp"), 'redtag');
        tb.insert('end',"\n");

        tb.configure(state = 'disabled') # Disable
    def memento(self):
        return self.ling
    def set_memento(self, memento):
        self.refresh(VMessage(memento))
