# -*- coding: utf-8 -*-

# Copyright 2006-2012 Borislav Rizov <bobyATdclDOTbasDOTbg>, Department of Computational Linguistic, Institute for Bulgarian Language – Bulgarian Academy of Sciences
# 
# This file is part of Hydra.
# 
# Hydra is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Hydra is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Hydra.  If not, see <http://www.gnu.org/licenses/>.

from Tix import *
from common import *
from observer_context import VM

class UndoControler(Frame):
	def __init__(self, parent, history):
		Frame.__init__(self, parent)
		self.history = history
		
		self.redo_button = Button(self, text = "redo", command = self.redo, state = "disabled")
		self.undo_button = Button(self, text = "undo", command = self.undo, state = "disabled")
		self.undo_button.pack(side = "left")
		self.redo_button.pack(side = "left")
		self.history.attach(self, VM.Text)
# 		self.refresh(None)
	def refresh_buttons(self):
		if self.history.possible_undo():
			self.undo_button["state"] = "normal"
		else:
			self.undo_button["state"] = "disabled"
		if self.history.possible_redo():
			self.redo_button["state"] = "normal"
		else:
			self.redo_button["state"] = "disabled"
	def message(self, data):
		showinfo("", data, parent = self)
	def refresh(self, message):
		data = message.data
		if data:
			self.message(data)
		else:
			self.refresh_buttons()
	def undo(self):
		self.history.undo()
	def redo(self):
		self.history.redo()
		
