# -*- coding: utf-8 -*-

# Copyright 2006-2012 Borislav Rizov <bobyATdclDOTbasDOTbg>, Department of Computational Linguistic, Institute for Bulgarian Language – Bulgarian Academy of Sciences
# 
# This file is part of Hydra.
# 
# Hydra is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Hydra is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Hydra.  If not, see <http://www.gnu.org/licenses/>.

from relations import *

rd = RelationsDict()

def ling(id):
# 	from linguistic_units import Literal, Synset, Note
	if type(id) == str:
		#print type(id), id
		raise Exception("WORDNET LING")
	if(id >=1000000000):
		return Synset(id)
	if(id >= 10000000):
		return Note(id)
	return Literal(id)

wn.relations = rd.relations
wn.sys_relations = rd.sys_relations
wn.ling = ling
wn.langs = wn.create_langs()

def create_note_formula():
	disj = []
	for name, rel in wn.relations.iteritems():
		if rel['id2'] is Note:
			if rel['id1'] is Synset:
				form = "<%s>" % name
			if rel['id1'] is Literal:
				form = "<Literal><%s>" % name
			disj.append(form + "%(nid)s")
	formula = "|".join(disj)
	return formula

Note.formula = create_note_formula()


